/*
** main.c
**
** STUDENT: DRAGAN DRAGOS-ANDREI
** GRUPA: 331CB
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "lcd.h"



typedef struct matrici{
	char mat[3][3];
	int posx;
	int posy;
	char win;
	int term;
	
}matrici;


//Functia de schimbare a matricii curente de diminesiune 3x3
int changeMatrix(int a, int b){
	if(a == 0 && b == 0){
		return 0;
	}
	if(a == 0 && b == 1){
		return 1;
	}
	if(a == 0 && b == 2){
		return 2;
	}
	if(a == 1 && b == 0){
		return 3;
	}
	if(a == 1 && b == 1){
		return 4;
	}
	if(a == 1 && b == 2){
		return 5;
	}
	if(a == 2 && b == 0){
		return 6;
	}
	if(a == 2 && b == 1){
		return 7;
	}
	if(a == 2 && b == 2){
		return 8;
	}
}


//Functia de afisare a unei matrici din matricea mare
void matrixDisplay(char a[3][3]){
lcd_goto_xy(3,2);
	lcd_str("[");
	lcd_goto_xy(4,2);
	lcd_chr(a[0][0]);
	lcd_goto_xy(5,2);
	lcd_str("]");
	
	
	lcd_goto_xy(6,2);
	lcd_str("[");
	lcd_goto_xy(7,2);
	lcd_chr(a[0][1]);
	lcd_goto_xy(8,2);
	lcd_str("]");
	
	lcd_goto_xy(9,2);
	lcd_str("[");
	lcd_goto_xy(10,2);
	lcd_chr(a[0][2]);
	lcd_goto_xy(11,2);
	lcd_str("]");
	
	lcd_goto_xy(3,4);
	lcd_str("[");
	lcd_goto_xy(4,4);
	lcd_chr(a[1][0]);
	lcd_goto_xy(5,4);
	lcd_str("]");
	
	
	lcd_goto_xy(6,4);
	lcd_str("[");
	lcd_goto_xy(7,4);
	lcd_chr(a[1][1]);
	lcd_goto_xy(8,4);
	lcd_str("]");
	
	lcd_goto_xy(9,4);
	lcd_str("[");
	lcd_goto_xy(10,4);
	lcd_chr(a[1][2]);
	lcd_goto_xy(11,4);
	lcd_str("]");
	
	lcd_goto_xy(3,6);
	lcd_str("[");
	lcd_goto_xy(4,6);
	lcd_chr(a[2][0]);
	lcd_goto_xy(5,6);
	lcd_str("]");
	
	
	lcd_goto_xy(6,6);
	lcd_str("[");
	lcd_goto_xy(7,6);
	lcd_chr(a[2][1]);
	lcd_goto_xy(8,6);
	lcd_str("]");
	
	lcd_goto_xy(9,6);
	lcd_str("[");
	lcd_goto_xy(10,6);
	lcd_chr(a[2][2]);
	lcd_goto_xy(11,6);
	lcd_str("]");
	

}

/* main -- Program starts here */
int main(void)
{
	// Setup LCD
	lcd_init();
	lcd_clear();
	lcd_contrast(0x40);
	DDRC &= ~(1 << PC0);
	DDRC &= ~(1 << PC1);
	DDRC &= ~(1 << PC2);
	DDRC &= ~(1 << PC3);
	DDRC &= ~(1 << PC4);
	
	PORTC |= (1 << PC0);
	PORTC |= (1 << PC1);
	PORTC |= (1 << PC2);
	PORTC |= (1 << PC3);
	PORTC |= (1 << PC4);
	

	matrici m[9];
	int i,j,k;
	
	for(i = 0;i<9;i++){
		if(i<3){
			m[i].posx = 0;
			m[i].posy = i;
			m[i].win = 'n';
			m[i].term = 0;
		}
		if((i>=3) && (i<6)){
			m[i].posx = 1;
			m[i].posy = i-3;
			m[i].win = 'n';
			m[i].term = 0;
		}
		if((i>=6) && (i<9)){
			m[i].posx = 2;
			m[i].posy = i-6;
			m[i].win = 'n';
			m[i].term = 0;
		}
	}
	
	
	//cazul initial
	for(k = 0;k<9;k++){
	for(i = 0;i<3;i++){
		for(j = 0;j<3;j++){
			m[k].mat[i][j] = '1';
		}
	}
}	
	
	lcd_goto_xy(1,1);
	printf("%d",m[4].posx);
	lcd_goto_xy(14,1);
	printf("%d",m[4].posy);
	//matrixDisplay(m[4].mat);
	char cursor = '-';
	char sign = 'x';
	
	
	//int cursX = 7;
	//int cursY = 4;
	//lcd_goto_xy(cursX,cursY);
	int aux = 4;
	int ind1 = 0;
	int ind2 = 0;
	m[aux].mat[ind1][ind2] = cursor;
	matrixDisplay(m[aux].mat);
	
	
	while(1){
	
	//Apasare buton dreapta
	
	if ((PINC & (1 << PC3)) == 0) {
		if(ind2 == 0){
			m[aux].mat[ind1][0] = '1';
			m[aux].mat[ind1][1] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind2 = 1;
			
			while(2){
			matrixDisplay(m[aux].mat);
			break;
			}
			lcd_delay();
		}
		
		else if(ind2 == 1){
			m[aux].mat[ind1][1] = '1';
			m[aux].mat[ind1][2] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind2 = 2;
			
			matrixDisplay(m[aux].mat);
			lcd_delay();
		}
		else{}
		
		}
		
		
		//Apasare buton stanga
	
	if ((PINC & (1 << PC0)) == 0) {
		if(ind2 == 2){
			m[aux].mat[ind1][2] = '1';
			m[aux].mat[ind1][1] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind2 = 1;
			matrixDisplay(m[aux].mat);
			lcd_delay();
			
		}
		else if (ind2 == 1){
			m[aux].mat[ind1][1] = '1';
			m[aux].mat[ind1][0] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind2 = 0;
			matrixDisplay(m[aux].mat);
			lcd_delay();
		}
		else{}
	}
	
	//Apasare buton jos

		if ((PINC & (1 << PC2)) == 0) {
			if(ind1 == 0){
			m[aux].mat[0][ind2] = '1';
			m[aux].mat[1][ind2] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind1 = 1;
			matrixDisplay(m[aux].mat);
			lcd_delay();
			
		}
		else if (ind1 == 1){
			m[aux].mat[1][ind2] = '1';
			m[aux].mat[2][ind2] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind1 = 2;
			matrixDisplay(m[aux].mat);
			lcd_delay();
		}
		else{}
		
		}
		
		//Apasare buton sus
		
		if ((PINC & (1 << PC4)) == 0) {
			if(ind1 == 2){
			m[aux].mat[2][ind2] = '1';
			m[aux].mat[1][ind2] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind1 = 1;
			matrixDisplay(m[aux].mat);
			lcd_delay();
			
		}
		else if (ind1 == 1){
			m[aux].mat[1][ind2] = '1';
			m[aux].mat[0][ind2] = cursor;
			lcd_clear();
			
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			ind1 = 0;
			matrixDisplay(m[aux].mat);
			lcd_delay();
		}
		else{}
		
		}
		
		
		//Apasare buton insert
		
		if ((PINC & (1 << PC1)) == 0) {
			if(sign == 'x' && m[aux].mat[ind1][ind2]!='0'){
				m[aux].mat[ind1][ind2] = sign;
				sign = '0';
				lcd_clear();
				
			aux = changeMatrix(ind1,ind2);
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			matrixDisplay(m[aux].mat);
			_delay_ms(100);
			}
			else if(sign == '0' && m[aux].mat[ind1][ind2]!='x'){
				m[aux].mat[ind1][ind2] = sign;
				sign = 'x';
				lcd_clear();
		
			aux = changeMatrix(ind1,ind2);
			lcd_goto_xy(1,1);
			printf("%d",m[aux].posx);
			lcd_goto_xy(14,1);
			printf("%d",m[aux].posy);
			matrixDisplay(m[aux].mat);
			_delay_ms(100);
			}
			
			
		
		}		
	}

}
